/*
  Copyright 2003 Rikard Bjrklind, Mikael Gransell

  This file is part of dc-qt.

  dc-qt is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
  dc-qt is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with dc-qt; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "chatwdgt.h"
#include <qtextedit.h>
#include <qlineedit.h>
#include <qlayout.h>
#include <qlabel.h>
#include <qpushbutton.h>

ChatWdgt::ChatWdgt(bool priv,QWidget *parent,const char *name) : QWidget(parent,name)
{
     QGridLayout *layout = new QGridLayout(this,2,3);
     chatText = new QTextEdit(this, "chat text");
     chatText->setTextFormat( PlainText );
     chatText->setReadOnly( true );
     chatText->viewport()->setFocus();

     chatEdit = new QLineEdit(this, "chat edit");
     QLabel *laban = new QLabel("Chat:",this,"chatlabel");
     connect( chatEdit, SIGNAL( returnPressed() ), this, SLOT( handleReturn() ) );
     QPushButton *btn = new QPushButton("X",this,"CloseButton");
     connect( btn, SIGNAL(pressed()), this, SLOT( emitClose() ) );
     if( !priv ) btn->setDisabled(true);
     btn->setFlat(true);

     layout->addMultiCellWidget( chatText,0,0,0,2 );
     layout->addWidget( laban, 1,0);
     layout->addWidget( chatEdit, 1,1);
     layout->addWidget( btn, 1,2);
}

void ChatWdgt::addChatStr(const QString& str)
{
     chatText->append(str);
}

void ChatWdgt::handleReturn()
{
     emit newChatStr( chatEdit->text(), this );
     chatEdit->clear();
}

void ChatWdgt::emitClose()
{
     emit close(this);
}
