#ifndef _MAINWDGT_H_
#define _MAINWDGT_H_

#include <qtabwidget.h>
#include <qpopupmenu.h>
#include <qlineedit.h>
#include <qmainwindow.h>
#include "hubwdgt.h"
#include "debugdlg.h"

class TransferDlg;
class QAction;

class MainWdgt : public QMainWindow
{

     Q_OBJECT

public:
     MainWdgt( QWidget* parent = 0, const char* name = 0 ); 

public slots:
          
     /*!
       Slot that displays a simplae dialog with
       info about the application
      */
     void displayAbout();
   
     /*!
       Slot that displays the about qt dialog.
      */
     void displayAboutQt();


     /*!
       Slot for making a search in all hubs that we are connected to.
       Retreives the search string and then emits a search signal with
       the search string so the hub widgets can perform the search.
     */
     void search(){}

     /*!
       Slot for creating a new hub tab, used to connet to a hub.
     */
     void newHubTab();

     /*!
       Slot for removing a hub tab when the user has pressed the close
       button

      */
     void closeHubTab( );

     /*!
       Brings up the preferences dialog.
     */
     void showPreferences();

     void setHubName(const QString &name, QWidget *wdgt);

     /// Connects the current hub
     void connectHub();
     
     /// Disconnects the current hub
     void disHub();
     
     /// Brings up the search dialog
     void searchHub();

     void selectHub(QWidget*);

    // Slot for handling multihub searh results
    void dispatchSearchResult(const QString& u,const QString& f,const QString& s,const QString& sl,const QString& hubname);
    void hubDisconnected(int id);
signals:
     /*!
       Signal that is emitted when a user wants to search the hubs
       we are connected to at the moment
      */
     void search( const QString& str );

private:
     /*!
       Line edit for entering search strings
      */
     QLineEdit* searchEdit;

     /*!
       The tab widget that holds our hub tabs
      */
     QTabWidget* hubTabs;

     /*!
       The transfer dialog
     */
     TransferDlg* transferWin;

     virtual void closeEvent( QCloseEvent *e);

     QAction *aConnect;
     QAction *aDisconnect;
};

#endif

/*
 *
 * $Log:
 *
 */
